From c5e570bedb77399d97f2c8c44a71fd84e7ef6b47 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 23 2020 00:10:12 +0000
Subject: [PATCH 330/2232] Merge pull request #134 from dtolnay/receiver


Trigger error on unrecognized ident in receiver's type
---

diff --git a/syntax/check.rs b/syntax/check.rs
index fa51ed3..f6e46fd 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -141,6 +141,14 @@ fn check_api_struct(cx: &mut Check, strct: &Struct) {
 
 fn check_api_fn(cx: &mut Check, efn: &ExternFn) {
     if let Some(receiver) = &efn.receiver {
+        if !cx.types.structs.contains_key(&receiver.ty)
+            && !cx.types.cxx.contains(&receiver.ty)
+            && !cx.types.rust.contains(&receiver.ty)
+        {
+            let span = span_for_receiver_error(receiver);
+            cx.error(span, "unrecognized receiver type");
+        }
+
         if receiver.lifetime.is_some() {
             let span = span_for_receiver_error(receiver);
             cx.error(span, "references with explicit lifetimes are not supported");
diff --git a/tests/ui/unrecognized_receiver.rs b/tests/ui/unrecognized_receiver.rs
new file mode 100644
index 0000000..823bfcf
--- /dev/null
+++ b/tests/ui/unrecognized_receiver.rs
@@ -0,0 +1,8 @@
+#[cxx::bridge]
+mod ffi {
+    extern "C" {
+        fn f(self: &Unrecognized);
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/unrecognized_receiver.stderr b/tests/ui/unrecognized_receiver.stderr
new file mode 100644
index 0000000..a44bec1
--- /dev/null
+++ b/tests/ui/unrecognized_receiver.stderr
@@ -0,0 +1,5 @@
+error: unrecognized receiver type
+ --> $DIR/unrecognized_receiver.rs:4:20
+  |
+4 |         fn f(self: &Unrecognized);
+  |                    ^^^^^^^^^^^^^

